

datatype intBoolList = IBNIL | IBCONS of int * boolIntList
  and boolIntList = BINIL | BICONS of bool * intBoolList



fun intBoolLen (iblst:intBoolList) : int = 
  (case iblst of 
      IBNIL => 0
    | IBCONS (_,xs) => 1 + boolIntLen xs
  )
and boolIntLen (bilst:boolIntList) : int = 
  (case bilst of 
      BINIL => 0
    | BICONS (_,xs) => 1 + intBoolLen xs
  )
















datatype ibwrapper = IB of intBoolList | BI of boolIntList

fun lens (lst:ibwrapper) : int = 
  case lst of 
      IB IBNIL => 0
    | IB (IBCONS (_,xs)) => 1 + lens (BI xs)
    | BI BINIL => 0
    | BI (BICONS (_,xs)) => 1 + lens (IB xs)

















datatype ib2 = IBNIL2 | IBCONS2 of int | IBCONS2' of int * bool * ib2 
datatype bi2 = BINIL2 | BICONS2 of bool | BICONS2' of bool * int * bi2