
datatype intOrBool = INT of int | BOOL of bool 

(*
 * intCount : intOrBool list -> int
 * REQUIRES: true
 * ENSURES: intCount lst ==> the number of INT elements in lst
 *)
fun intCount (lst:intOrBool list) : int = 
  case lst of 
      [] => 0 
    | (INT _)::xs => 1 + intCount xs 
    | _::xs => intCount xs

val 0 = intCount [] 
val 1 = intCount [INT 1]
val 0 = intCount [BOOL true]
val 2 = intCount [INT 1, BOOL true, BOOL false, INT 5, BOOL true]