

datatype intList = NIL | CONS of int * intList

(*
 * convert: int list -> intList
 * REQUIRES: true
 * ENSURES: convert lst ==> the intList equivalent of lst
 *)
fun convert (lst:int list) : intList = 
  case lst of 
      [] => NIL 
    | x::xs => CONS (x, convert xs)

val NIL = convert [] 
val CONS (1, CONS (2, CONS (3, NIL))) = convert [1,2,3]